# class MCollective::Aggregate::Base

### Attributes

action[RW]
aggregate_format[RW]
arguments[RW]
name[RW]
output_name[RW]
result[RW]

### Public Class Methods

new(output_name, arguments, aggregate_format, action) click to toggle source

    # File lib/mcollective/aggregate/base.rb, line 6
    def initialize(output_name, arguments, aggregate_format, action)
      @name = self.class.to_s
      @output_name = output_name

      # Any additional arguments passed in the ddl after the output field will
      # be stored in the arguments array which can be used in the function
      @arguments = arguments
      @aggregate_format = aggregate_format
      @action = action
      @result = {:value => nil, :type => nil, :output => output_name}

      startup_hook
    end

### Public Instance Methods

result_class(type) click to toggle source

    # File lib/mcollective/aggregate/base.rb, line 35
    def result_class(type)
      Result.const_get("#{type.to_s.capitalize}Result")
    end

summarize() click to toggle source

Stops execution of the function and returns a specific ResultObject, aggregate functions will most likely override this but this is the simplest case so we might as well default to that

    # File lib/mcollective/aggregate/base.rb, line 29
    def summarize
      raise "Result type is not set while trying to summarize aggregate function results" unless @result[:type]

      result_class(@result[:type]).new(@result, @aggregate_format, @action)
    end